var SoapService = require("./SoapService.js"), DocumentScheme = require("./DocumentScheme.js");

var billon = {
	
};

billon.Shop = function () {
	this.Merchant = false;
	this.App24 = false;
	
	this.Product = function () {
		return false;
	};
	
	this.ProductDelivery = function () {
		return false;
	};
	
	this.ProductDownload = function () {
		return false;
	};
	
	this.PaymentTitle = function () {
		return false;
	};
	
	this.OnFinishedPayment = function () {
		console.log("Finished some payment.");
	};
	
	this.DocumentParse = function () {
		return false;
	};
};


// HELPERS
var isFunction = function (func) {
	if (typeof func !== "function") {
		return false;
	}
	
	return true;
};

var deliveryOptions = {
	"NOT_NEEDED": 0,
	"OPTIONAL": 1,
	"OBLIGATORY": 2
};

var uniqueId = function () {
	var text = new Date().getTime()+Math.random(1,500000);
	var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!@#$%^&*()";

	for (var i = 0; i < 5; i++) {
		text += possible.charAt(Math.floor(Math.random() * possible.length));
	}
	
	return text;
};

var taskTracker = {};

// ERRORS
var errs = {
	ERR_INVALID_QUERY: {
		err: "ERR_INVALID_QUERY",
		description: "Missing query."
	},
	ERR_INVALID_QUERY_DATA: {
		err: "ERR_INVALID_QUERY_DATA",
		description: "Data must be an object."
	},
	ERR_INVALID_ITEMS_ID: {
		err: "ERR_INVALID_ITEMS_ID",
		description: "Data.itemsId must be an object."
	},
	ERR_INVALID_USER: {
		err: "ERR_INVALID_USER",
		description: "Data.user must be an object."
	},
	ERR_INVALID_USER_USERNAME: {
		err: "ERR_INVALID_USER_USERNAME",
		description: "Data.user.userName must be a string with minimum 4 characters length."
	},
	ERR_INVALID_TASKID: {
		err: "ERR_INVALID_TASKID",
		description: "Invalid taskId sent."
	},
	ERR_TASK_DOES_NOT_EXIST: {
		err: "ERR_TASK_DOES_NOT_EXISTS",
		description: "Task does not exists."
	}
};

billon.Shop.prototype = {
	merchant: function (func) {
		if (!isFunction(func)) {
			console.log("Shop.merchant parameter must be a function.");
			return false;
		}
		
		this.Merchant = func;
		return this;
	},
	app24: function (func) {
		if (!isFunction(func)) {
			console.log("Shop.app24 parameter must be a function.");
			return false;
		}
		
		this.App24 = func;
		return this;
	},
	product: function (func) {
		if (!isFunction(func)) {
			console.log("Shop.product parameter must be a function.");
			return false;
		}
		
		this.Product = func;
		return this;
	},
	productDelivery: function (func) {
		if (!isFunction(func)) {
			console.log("Shop.productDelivery parameter must be a function.");
			return false;
		}
		
		this.ProductDelivery = func;
		return this;
	},
	productDownload: function (func) {
		if (!isFunction(func)) {
			console.log("Shop.productDownload parameter must be a function.");
			return false;
		}
		
		this.ProductDownload = func;
		return this;
	},
	documentParse: function (func) {
		if (!isFunction(func)) {
			console.log("Shop.documentParse parameter must be a function.");
			return false;
		}
		
		this.DocumentParse = func;
		return this;
	},
	paymentTitle: function (func) {
		if (!isFunction(func)) {
			console.log("Shop.paymentTitle parameter must be a function.");
			return false;
		}
		
		this.PaymentTitle = func;
		return this;
	},
	onFinishedPayment: function (func) {
		if (!isFunction(func)) {
			console.log("Shop.onFinishedPayment parameter must be a function.");
			return false;
		}
		
		this.OnFinishedPayment = func;
		return this;
	},
	donateInitiation: function (req, res) {
		var self = this;
		if (typeof req.body !== "object") {
			return res.send(errs.ERR_INVALID_QUERY);
		}
		
		var requestData = req.body;
		
		if (typeof requestData.user !== "object") {
			return res.send(errs.ERR_INVALID_USER);
		}
		
		if (typeof requestData.amount !== "number") {
			return res.send(errs.ERR_INVALID_ITEMS_ID);
		}
		
		if (typeof requestData.user.userName !== "string" || requestData.user.userName.length < 4) {
			return res.send(errs.ERR_INVALID_USER_USERNAME);
		}
		
		var paymentData = {
			user: requestData.user,
			amount: requestData.amount
		};
		
		var requestInvoiceData = "NOT_NEEDED";
		var requestDeliveryData = "NOT_NEEDED";
		var wui = self.App24(requestData);
		
		var document = DocumentScheme();
		var parsedDocument = this.DocumentParse(document, requestData);
		if (parsedDocument !== false) {
			console.log(parsedDocument);
			document = parsedDocument;
		}
		
		var data = {
			WUI: wui,
			params: {
				type: "NORMAL",
				amount: {
					amount: paymentData.amount,
					currency: "PLN"
				},
				requestData: {
					username: paymentData.user.userName,
					uniqueTransferId: uniqueId(),
					title: self.PaymentTitle(),
					requestInvoiceData: requestInvoiceData,
					requestDeliveryData: requestDeliveryData,
					description: document ? JSON.stringify(document) : null
				}
			}
		};
		
		SoapService.call["requestPaymentInitiation"](data, function(requestResponse) {
			
			if (requestResponse.requestStatus === "SUCCESS") {
				taskTracker[requestResponse.taskId] = {
					WUI: wui,
					paymentData: paymentData
				};
				var interval = setInterval(function(){
					SoapService.call["getTaskStatus"]({
						WUI: wui,
						params: {
							taskId: requestResponse.taskId
						}
					}, function(taskResponse){
						if (taskResponse.requestStatus !== "SUCCESS") {
							console.log(taskResponse);
							setInterval(function(){
								delete taskTracker[requestResponse.taskId];
							}, 30000);
							return clearInterval(interval);
						};
						
						if (taskResponse.status.split("_")[0] === "FINISHED" || taskResponse.progressPercent === 100) {
							clearInterval(interval);
							setInterval(function(){
								delete taskTracker[requestResponse.taskId];
							}, 30000);
						}
						
						if (taskResponse.status === "FINISHED_OK") {
							self.OnFinishedPayment(paymentData);
						}
						
					});
				}, 5000);
			}
			
			res.json(requestResponse);
		});
	},
	paymentInitiation: function (req, res) {
		var self = this;
		if (typeof req.body !== "object") {
			return res.send(errs.ERR_INVALID_QUERY);
		}
		
		var requestData = req.body;
		
		if (typeof requestData.user !== "object") {
			return res.send(errs.ERR_INVALID_USER);
		}
		
		if (typeof requestData.itemsId !== "object") {
			return res.send(errs.ERR_INVALID_ITEMS_ID);
		}
		
		if (typeof requestData.user.userName !== "string" || requestData.user.userName.length < 4) {
			return res.send(errs.ERR_INVALID_USER_USERNAME);
		}
		
		var paymentData = {
			user: requestData.user,
			itemsId: requestData.itemsId,
			deliveryId: requestData.deliveryId
		};
		
		var document = DocumentScheme();
		var parsedDocument = this.DocumentParse(document, requestData);
		if (parsedDocument !== false) {
			document = parsedDocument;
		}
		
		var requestInvoiceData = "NOT_NEEDED";
		var requestDeliveryData = "NOT_NEEDED";
		
		// Wczytanie produktów.
		for (var i = 0; i < paymentData.itemsId.length; i++) {
			var itemId = paymentData.itemsId[i];
			var item = this.Product(itemId);
			item.unit_price_net = parseInt(item.unit_price_net * 1000);
			console.log(item.unit_price_net);
			item.amount_net = item.unit_price_net * item.quantity;
			document.sales_document_data.total_amount_net += item.amount_net;
			item.amount_gross = item.amount_gross * 1000;
			document.sales_document_data.total_amount_gross += item.amount_gross * item.quantity;
			
			// Sprawdzenie czy potrzeba danych do faktury lub dostawy.
			if (deliveryOptions[item.requestInvoiceData] > deliveryOptions[requestInvoiceData]) {
				requestInvoiceData = item.requestInvoiceData;
			}
			
			if (deliveryOptions[item.requestDeliveryData] > deliveryOptions[requestDeliveryData]) {
				requestDeliveryData = item.requestDeliveryData;
			}
			
			// Pomnożenie vat'u do danych dokumentu.
			item.vat.amount *= 1000;

			// Dodanie produktu do listy.
			document.sales_document_data.items.push(item);
		}
		
		// Wczytanie opcji dostawy.
		document.sales_document_data.delivery_option = self.ProductDelivery(document.sales_document_data.items);
		
		// Wczytanie danych sprzedawcy.
		document.seller_data = self.Merchant(document.sales_document_data.items, document.sales_document_data.delivery_option);
		
		// Ustalenie daty.
		document.sales_document_data.sales_document_date = new Date().getTime();
		document.sales_document_data.trade_date = new Date().getTime();
		
		var wui = self.App24(document.sales_document_data.items, document.sales_document_data.delivery_option);
		var data = {
			WUI: wui,
			params: {
				type: "NORMAL",
				amount: {
					amount: document.sales_document_data.total_amount_gross,
					currency: "PLN"
				},
				requestData: {
					username: paymentData.user.userName,
					uniqueTransferId: uniqueId(),
					title: self.PaymentTitle(document.sales_document_data.items, document.sales_document_data.delivery_option),
					requestInvoiceData: requestInvoiceData,
					requestDeliveryData: requestDeliveryData,
					description: JSON.stringify(document)
				}
			}
		};
		
		SoapService.call["requestPaymentInitiation"](data, function(requestResponse) {
			
			if (requestResponse.requestStatus === "SUCCESS") {
				taskTracker[requestResponse.taskId] = {
					WUI: wui,
					items: document.sales_document_data.items,
					delivery: document.sales_document_data.delivery_option,
					document: document
				};
				var interval = setInterval(function(){
					SoapService.call["getTaskStatus"]({
						WUI: wui,
						params: {
							taskId: requestResponse.taskId
						}
					}, function(taskResponse){
						if (taskResponse.requestStatus !== "SUCCESS") {
							console.log(taskResponse);
							setInterval(function(){
								delete taskTracker[requestResponse.taskId];
							}, 30000);
							return clearInterval(interval);
						};
						
						if (taskResponse.status.split("_")[0] === "FINISHED" || taskResponse.progressPercent === 100) {
							clearInterval(interval);
							setInterval(function(){
								delete taskTracker[requestResponse.taskId];
							}, 30000);
						}
						
						if (taskResponse.status === "FINISHED_OK") {
							self.OnFinishedPayment(document.sales_document_data.items, document.sales_document_data.delivery_option, document, requestData);
						}
						
					});
				}, 5000);
			}
			
			res.json(requestResponse);
		});
		
	},
	paymentStatus: function (taskId, cb) {
		if (typeof taskId !== "string") {
			return cb(errs.ERR_INVALID_TASKID);
		}
		
		var self = this;
		var taskData = taskTracker[taskId];
		if (typeof taskData === "undefined") {
			return cb(errs.ERR_TASK_DOES_NOT_EXIST);
		}
		
		SoapService.call["getTaskStatus"]({
			WUI: taskData.WUI,
			params: {
				taskId: taskId
			}
		}, function (taskResponse) {
			if (typeof taskResponse.status === "string" && taskResponse.status === "FINISHED_OK") {
				taskResponse.agent = {
					download: self.ProductDownload(taskData.items, taskData.delivery, taskData.document)
				};
			}
			
			if (cb) {
				cb(taskResponse);
			}
		});
	}
};

module.exports = billon;